% PStill run-time script, F. Siegert, August 1998, v1.00
% Use this to do specific additions to the PDF engine
% DO NOT TOUCH IT IF YOU DO NOT UNDERSTAND IT EXCEPT FOR THE LINE
% MARKED **** IN CASE OF TROUBLES WITH ANNOTATIONS

variable annotstring = "";
variable viewstring = "";
variable validAnnotation = 0;
variable insertionPage = 0;

% Utility function to produce output for the log file
define printf (n)
{
   fputs (Sprintf (n), stdout); pop ();
   fflush (stdout); pop ();
}

% further utilty functions are

% void objToAnnotation(int pagenumber, string annotation)

% addToContent(string line)

% actions are called by PDF engine whenever a special event happens

% action_pdfmark - collects and filters PDF marks (annotations)
% called whenever a pdfmark dicionary entity is worked on
% s is a string and empty on end of dictionary
% n is a integer counter

define action_pdfmark(s,n) {

	% the string will be zero length at the end of the annoation, so process the collected data
	if (strlen(s) == 0) {
		if (validAnnotation > 0) {
			% We need to construct a destination for the link
			% #PAGEANNOT=### is a placeholder and will be replaced by dumpPDFBase() by the
			% object number for the ### page object at dumpTime, we take the rest from /View
			variable destination;
			if (strlen(viewstring) > 0) {
				destination = Sprintf("\n/Dest [ #PAGEANNOT=%d %s", insertionPage, viewstring ,2 );
			} else {
				destination = Sprintf("\n/Dest [ #PAGEANNOT=%d ]", insertionPage ,1 );
			}
			annotstring = strcat(annotstring,destination);

			% Define the complete annotation 
			% **** UNCOMMENT NEXT LINE TO TURN OFF PDF ANNOTATION PROCESSING
			objToAnnotation(curPageNum(),annotstring );
		}
		% set initial state
		annotstring = "";
		viewstring = "";
		validAnnotation = 0;
		return;
	}

	% is it the /Page key, we need to remember the target page, then drop key
	if (strncmp(s,"/Page",5) == 0) {
		insertionPage = integer( substr(s, 6, -1) );
		return;
	}

	% is it the /View key, we need to remember the target location, then drop key
	if (strncmp(s,"/View",5) == 0) {
		viewstring = substr(s, 8, -1);
		return;
	}

	% be sure to set a newline before adding anything
	if (strlen(annotstring) > 0) {
		annotstring = strcat(annotstring,"\n");
	} else {
		% set the current page as default target page
		insertionPage = curPageNum();

		% we process only old style LNK at the moment
		if (strcmp(s,"/LNK") == 0) {
			validAnnotation++;
			s = "/Link";
		}
	}

	% add to annotation, then return for next key/value pair string
	annotstring = strcat(annotstring,s);
	
}

% action_pagestart - called on start of each page description
define action_pagestart() {
	% addToContent(" % Start me up\n");
}

% action_pageend - called on end of each page description
define action_pageend() {
	% addToContent(" % End me down\n");
}

% END OF CONTROL SCRIPT